using System;
class HelloWorld 
{
    static void Main() 
    {
        string[] s = Console.ReadLine().Split(' ');
        int n = int.Parse(s[0]);
        int m = int.Parse(s[1]);
        int[,] x = new int[m,3];
        for(int i = 0; i < m; i++)
        {
            s = Console.ReadLine().Split(' ');
            x[i,0] = int.Parse(s[0]);
            x[i,1] = int.Parse(s[1]);
            x[i,2] = int.Parse(s[2]);
        }
        s = Console.ReadLine().Split(' ');
        int a = int.Parse(s[0]), b = int.Parse(s[1]);
        
        int a1 = a, br = 0, stanje = 0, min = int.MaxValue;
        int br1 = 0;
        for(int i = 0; i < m; i++)
        {
            if(x[i,0] == a)
            {
                br1++;
            }
        }
        for(int j = 0; j < m; j++)
        {
            a1 = a;
            for(int i = j; i < m; i++)
            {
                if(x[i,0] == a1)
                {
                    a1 = x[i,1];
                    if(x[i,2] != stanje)
                    {
                        stanje = x[i,2];
                        br++;
                    }
                    if(x[i,1] == b)
                    {
                        if(br < min)
                        {
                            min = br;
                        }
                        br = 0;
                        break;
                    }
                    i = 0;
                }
            }
        }
        if(br1 == 0 || min == int.MaxValue)
        {
            Console.WriteLine(-1);
        }
        else
        {
            Console.WriteLine(min);
        }
    }
}